=== debian/changelog ===
armory (0.92.3-1) unstable; urgency=medium

  * Initial release (Closes: #739405)
  * Patches
    - Remove convenience copies
    - Remove upgrade functionality
    - Fix empty functions that cause errors with dh_python2

 -- Joseph Bisch <joseph.bisch@gmail.com>  Tue, 07 Oct 2014 10:22:45 -0400
