=== debian/control ===
Source: armory
Section: net
Priority: optional
Maintainer: Joseph Bisch <joseph.bisch@gmail.com>
Build-Depends:
 debhelper (>= 9),
 libcrypto++-dev,
 libleveldb-dev,
 pyqt4-dev-tools,
 python-dev,
 python-psutil,
 python-qt4,
 python-twisted,
 rsync,
 swig
Standards-Version: 3.9.6
Homepage: http://www.bitcoinarmory.com/
Vcs-Git: https://anonscm.debian.org/git/users/josephbisch-guest/bitcoin-armory.git
Vcs-Browser: http://anonscm.debian.org/cgit/users/josephbisch-guest/bitcoin-armory.git

Package: armory
Architecture: any
Depends:
 bittornado,
 ${python:Depends},
 python-psutil,
 python-qt4,
 python-qt4reactor,
 python-twisted,
 xdg-utils,
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 bitcoind
Description: Advanced Bitcoin Wallet Management Software
 Armory is advanced program for managing multiple Bitcoin wallets with the
 highest level of security available. Use top-of-the-line wallet encryption,
 print permanent paper backups of your wallets, and store your Bitcoins on
 an offline computer for maximum security from online threats.
