=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --with python2

clean:
	dh clean
	rm -rf BitTornado
	rm -rf urllib3
	rm -rf cppForSwig/leveldb
	rm -rf cppForSwig/cryptopp
	rm -rf qt4reactor.py

override_dh_auto_test:

copyright_check:
	${MAKE} -f /usr/share/cdbs/1/rules/utils.mk debian/stamp-copyright-check
	rm debian/stamp-copyright-check
