=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/BitcoinArmory-$1\.tar\.gz/ \
  https://github.com/etotheipi/BitcoinArmory/tags .*/v?(\d\S*)\.tar\.gz
